Summary: "ACS" GNU Package - Adjunct Communication Server/IVR platform 
Name: ACS
Version: 0.5.7
Release: 1
Group: Daemons/Telephony
URL: http://www.voxilla.org/projects/projacs.html
Source: ftp://www.voxilla.org/pub/acs/ACS-%{PACKAGE_VERSION}.tar.gz
License: GPL
BuildRoot: /tmp/ACS-root
Packager: David Sugar <dyfet@ostel.com>

%description 
ACS is the GPL licensed multi-line Adjunct Communication Server.  ACS
offers a scriptable voice response development platform that is capable of
interfacing with various telephony hardware.  ACS supports hardware from
Pika corporation and Voicetronix under Linux. 

%package pika
Summary: ACS IVR server for Pika hardware using MonteCarlo API
Group: Daemons/Telephony
Requires: MonteCarlo
Requires: ACS

%description pika
This package provides the ACS daemon built under the Pika MonteCarlo
API.  It should support most Pika hardware configurations out of the box,
though no special features are yet implimented for Pika "digital" trunks.
The Pika MonteCarlo API must be installed seperately.

%package vpb
Summary: ACS IVR server for VoiceTronix VPB hardware and API
Group: Daemons/Telephony
Requires: Vpb-driver
Requires: ACS

%description vpb
This package provides the ACS daemon built for use with the VoiceTronix
VPB4 multi-line DSP telephony card.  It should support the VPB4 out of the
box and may support other VoiceTronix VPB series boards in the future.  The
VoiceTronix VPB driver for Linux must be installed seperately to use this
package, but is available as free software.

%package phone
Summary: ACS IVR server for Quicknet and generic /dev/phone support
Group: Daemons/Telephony
Requires: ACS

%description phone
This package provides the ACS daemon built for use with the Quicknet
LineJack card, and is also designed to encapsulate the functionality
required for any generic /dev/phone telephony driver starting with kernel
2.2.14.  This package will not work with pre GPL releases of the Quicknet
driver under Linux.

%prep
rm -rf $RPM_BUILD_ROOT

%setup
./configure --prefix=/usr --sysconfdir=/etc

%build
make

%install
mkdir -p $RPM_BUILD_ROOT/usr/share/aapackages
mkdir -p $RPM_BUILD_ROOT/usr/libexec/tgi
mkdir -p $RPM_BUILD_ROOT/usr/libexec/acs
mkdir -p $RPM_BUILD_ROOT/dev
mkdir -p $RPM_BUILD_ROOT/etc 
mkdir -p $RPM_BUILD_ROOT/usr/man/man8
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc0.d
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc1.d
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc2.d
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc3.d
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc4.d
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc5.d
make prefix=$RPM_BUILD_ROOT/usr sysconfdir=$RPM_BUILD_ROOT/etc install

%files
%doc NEWS COPYING INSTALL TODO README README.script README.shell README.vpb ChangeLog QuickStart
/usr/man/man8/umdctrl.8
/usr/man/man8/umdstop.8
/usr/man/man8/umdstat.8
/usr/man/man8/umd.8
/usr/man/man7/umd.conf.7
/usr/bin/rswords
/usr/bin/umdpkg
/usr/sbin/umdctrl
/usr/sbin/umdstat
/usr/sbin/umdstop
/usr/sbin/umd
/usr/include/ACS
/usr/share/aapackages
/usr/share/aaprompts
/usr/share/aascripts
/usr/libexec/acs
/usr/libexec/tgi
/usr/lib/lib*
/etc/rc.d/init.d/umd
/etc/rc.d/rc0.d/K00umd
/etc/rc.d/rc1.d/K00umd
/etc/rc.d/rc2.d/K00umd
/etc/rc.d/rc3.d/S99umd
/etc/rc.d/rc4.d/S99umd
/etc/rc.d/rc5.d/S99umd
%config /etc/umd.conf 
%config /etc/umd.sched

%files pika
/usr/sbin/umd_pika
%config /etc/pika.conf

%post pika
mknod -m 0600 /dev/pikacti0 c 70 0
mknod -m 0600 /dev/pikacti1 c 70 1
mknod -m 0600 /dev/pikacti2 c 70 2
mknod -m 0600 /dev/pikadsp0 c 71 0
mknod -m 0600 /dev/pikadsp1 c 71 1
mknod -m 0600 /dev/pikadsp2 c 71 2

%files vpb
/usr/sbin/umd_vpb

%files phone
/usr/sbin/umd_phone

%clean
rm -rf $RPM_BUILD_ROOT
rm -rf $RPM_BUILD_DIR/ACS-%{version}
