/*
** Copyright (C) 1999-2000 Open Source Telecom Corporation.
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**
** As a special exception to the GNU General Public License, permission is
** granted for additional uses of the text contained in its release
** of ACS as noted here.
**
** This exception is that permission is hereby granted to link ACS with
** the Pika MonteCarlo static libraries to produce a executable image
** without requiring MonteCarlo itself to be supplied in source form so
** long as each source file so linked contains this exclusion.
**
** This exception does not however invalidate any other reasons why
** the resulting executable file might be covered by the GNU General
** public license or invalidate the licensing requirements of any
** other component or library.
**
** This exception applies only to the code released by OST under the
** name ACS.  If you copy code from other releases into a copy of
** ACS, as the General Public License permits, the exception does not
** apply to the code that you add in this way.  To avoid misleading
** anyone as to the status of such modified files, you must delete
** this exception notice from them.
**
** If you write modifications of your own to ACS, it is your choice
** whether to permit this exception to apply to your modifications.
** If you do not wish that, delete this exception notice, at which
** point the terms of your modification would be covered under the GPL
** as explicitly stated in "COPYING".
*/

#ifndef	__AUFILE_H__
#define	__AUFILE_H__

#define	AU_FILE_MAGIC ((unsigned long)0x2e736e64)
#define	AU_SIZE_UNKNOWN	(~0l)

#define	AU_ENCODING_MULAW	1
#define	AU_ENCODING_PCM8	2
#define	AU_ENCODING_PCM16	3
#define	AU_ENCODING_PCM32	5
#define	AU_ENCODING_G721	23
#define	AU_ENCODING_G723	25
#define	AU_ENCODING_ALAW	27

#define	AU_SAMPLING_4khz	4000l
#define	AU_SAMPLING_6khz	6000l
#define	AU_SAMPLING_8khz	8000l
#define	AU_SAMPLING_11khz	11025l

typedef	unsigned char aulong[4];

#pragma	pack(1)

typedef	struct
{
	aulong	magic;
	aulong	hdrsize;
	aulong	datasize;
	aulong	encoding;
	aulong	sampling;
	aulong	channels;
	char	info[0];	/* 8 byte aligned */
}	AUFILE;

#pragma pack()

#ifdef	__cplusplus
extern "C" {
#endif

void	setaulong(aulong data, unsigned long val);
unsigned long getaulong(aulong data);

#ifdef	__cplusplus
}
#endif

#endif
