dnl Copyright (C) 1999-2000 Open Source Telecom Corporation.
dnl  
dnl This program is free software; you can redistribute it and/or modify
dnl it under the terms of the GNU General Public License as published by
dnl the Free Software Foundation; either version 2 of the License, or
dnl (at your option) any later version.
dnl 
dnl This program is distributed in the hope that it will be useful,
dnl but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl GNU General Public License for more details.
dnl 
dnl You should have received a copy of the GNU General Public License
dnl along with this program; if not, write to the Free Software 
dnl Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
dnl 
dnl As a special exception to the GNU General Public License, if you 
dnl distribute this file as part of a program that contains a configuration 
dnl script generated by Autoconf, you may include it under the same 
dnl distribution terms that you use for the rest of that program.

AC_DEFUN(OST_CC_DAEMON,[
	AC_REQUIRE([OST_SYS_POSIX])
	AC_REQUIRE([OST_CC_SIGNAL])
	AC_REQUIRE([AC_TYPE_PID_T])
	AC_CHECK_HEADERS(sys/resource.h sysexits.h)
	AC_CHECK_FUNCS(pdetach)
])

AC_DEFUN(OST_LIB_WRAPPER,[
	AC_REQUIRE([OST_LIB_SOCKET])
	AC_CHECK_HEADERS(tcpd.h)
	AC_CHECK_LIB(wrap, request_init, [
		LIBS="-lwrap $LIBS"])
])

AC_DEFUN(OST_LIB_DYNAMIC,[
	DYN_LOADER=''
	AC_REQUIRE([OST_SYS_POSIX])
	AC_CHECK_HEADERS(dlfcn.h)
	AC_CHECK_LIB(dl, dlopen, [DYN_LOADER=-ldl])
	if test ! -z "$DYN_LOADER" ; then
		AC_DEFINE(HAVE_MODULES)
	fi
	AC_SUBST(DYN_LOADER)	
])

dnl ACCONFIG TEMPLATE
dnl #undef HAVE_SYS_RESOURCE_H
dnl #undef HAVE_PDETACH
dnl #undef HAVE_SYSEXITS_H
dnl #undef HAVE_TCPD_H
dnl #undef HAVE_DLOPEN
dnl #undef HAVE_MODULES
dnl END ACCONFIG

dnl ACCONFIG BOTTOM
dnl  
dnl #ifdef HAVE_SYS_RESOURCE_H
dnl #include <sys/resource.h>
dnl #endif
dnl 
dnl #ifdef HAVE_DLFCN_H
dnl #include <dlfcn.h>
dnl #endif
dnl 
dnl #ifdef HAVE_SYSEXITS_H
dnl #include <sysexits.h>
dnl #endif
dnl 
dnl #ifdef HAVE_TCPD_H
dnl #include <tcpd.h>
dnl #endif
dnl 
dnl #ifndef EX_OK
dnl #define EX_OK 0
dnl #endif
dnl #ifndef EX_USAGE
dnl #define EX_USAGE 64
dnl #endif
dnl #ifndef EX_DATAERR
dnl #define EX_DATAERR 65
dnl #endif
dnl #ifndef EX_NOINPUT
dnl #define EX_NOINPUT 66
dnl #endif
dnl #ifndef EX_NOUSER
dnl #define EX_NOUSER 67
dnl #endif
dnl #ifndef EX_NOHOST
dnl #define EX_NOHOST 68
dnl #endif
dnl #ifndef EX_UNAVAILABLE
dnl #define EX_UNAVAILABLE 69
dnl #endif
dnl #ifndef EX_SOFTWARE
dnl #define EX_SOFTWARE 70
dnl #endif
dnl #ifndef EX_OSERR
dnl #define EX_OSERR 71
dnl #endif
dnl #ifndef EX_OSFILE
dnl #define EX_OSFILE 72
dnl #endif
dnl #ifndef EX_CANTCREAT
dnl #define EX_CANTCREAT 73
dnl #endif
dnl #ifndef EX_IOERR
dnl #define EX_IOERR 74
dnl #endif
dnl #ifndef EX_TEMPFAIL
dnl #define EX_TEMPFAIL 75
dnl #endif
dnl #ifndef EX_PROTOCOL
dnl #define EX_PROTOCOL 76
dnl #endif
dnl #ifndef EX_NOPERM
dnl #define EX_NOPERM 77
dnl #endif
dnl #ifndef EX_CONFIG
dnl #define EX_CONFIG 78
dnl #endif
dnl #ifndef EX__MAX
dnl #define EX__MAX 78
dnl #endif
dnl 
dnl END ACCONFIG

