// Copyright (C) 2000 Open Source Telecom Corporation.
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#include <config.h>
#include <debug.h>
#include "server.h"
#include "trunk.h"

void Trunk::Busy(EventRecord *er)
{
	int	rtn;

	switch(er->event)
	{
	case UM_EVENT_ENTER_STATE:
		trap = false;
		endTimer();
		endDTMF();
		scrDetach();
		resetAudio();
		resetThreads();
		ioctl(device, PHONE_PSTN_SET_STATE, PSTN_OFF_HOOK);
		setCurrent("BUSY");
		offhook = true;
		debug(1, "trunk %02d made busy", id);
		break;

	case UM_EVENT_MAKE_BUSY:
		break;
	case UM_EVENT_MAKE_IDLE:
		debug(1, "trunk %02d restoring...", id);
	default:
		Default(er);
	}
}
