// Copyright (C) 1999-2000 Open Source Telecom Corporation
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#include <config.h>
#include <syslog.h>
#include <stdlib.h>
#include "server.h"
#include "trunk.h"
#include "vpbapi.h"

void Trunk::TrkSleep(EventRecord *er)
{
	int timer;
	char *arg;
	switch(er->event)
	{
	case UM_EVENT_ENTER_STATE:
		timer = atoi(getOption("1"));
		ring_count = atoi(getOption("0"));
		if(timer < 1)
			timer = 1;

		setTimer(timer * 1000);
		return;
	case UM_EVENT_RING_LINE:
		if(!ring_count)
			return;
		rings = ring_count = 0;
	case VPB_TIMEREXP:
		endTimer();
		break;
	case VPB_RING:
		Default(er);
		if(!ring_count)
			return;
		if(rings >= ring_count)
			break;
		return;
	default:
		Default(er);
		return;
	}
	if(rings < ring_count)
		setHandler((handler_t)&Trunk::Idle);
	else
		scrNext();
}
